VirtualBox Main API

Public Member Functions | Public Attributes | List of all members
ICertificate Interface Reference

X.509 certificate details. More...

Inheritance diagram for ICertificate:

## Public Member Functions
void | isCurrentlyExpired ([retval] out boolean result)
| Tests if the certificate has expired at the present time according to the X.509 validity of the certificate.
void | queryInfo (in long what, [retval] out wstring result)
| Way to extend the interface.

## Public Attributes
readonly attribute CertificateVersion | versionNumber
| Certificate version number.
readonly attribute wstring | serialNumber
| Certificate serial number.
readonly attribute wstring | signatureAlgorithmOID
| The dotted OID of the signature algorithm.
readonly attribute wstring | signatureAlgorithmName
| The signature algorithm name if known (if known).
readonly attribute wstring[] | issuerName
| Issuer name.
readonly attribute wstring[] | subjectName
| Subject name.
readonly attribute wstring | friendlyName
| Friendly subject name or similar.
readonly attribute wstring | validityPeriodNotBefore
| Certificate not valid before ISO timestamp.
readonly attribute wstring | validityPeriodNotAfter
| Certificate not valid after ISO timestamp.
readonly attribute wstring | publicKeyAlgorithmOID
| The dotted OID of the public key algorithm.
readonly attribute wstring | publicKeyAlgorithm
| The public key algorithm name (if known).
readonly attribute octet[] | subjectPublicKey
| The raw public key bytes.
readonly attribute wstring | issuerUniqueIdentifier
| Unique identifier of the issuer (empty string if not present).
readonly attribute wstring | subjectUniqueIdentifier
| Unique identifier of this certificate (empty string if not present).
readonly attribute boolean | certificateAuthority
| Whether this certificate is a certificate authority.
readonly attribute unsigned long | keyUsage
| Key usage mask.
readonly attribute wstring[] | extendedKeyUsage
| Array of dotted extended key usage OIDs.
readonly attribute octet[] | rawCertData
| The raw certificate bytes.
readonly attribute boolean | selfSigned
| Set if self signed certificate.
readonly attribute boolean | trusted
| Set if the certificate is trusted (by the parent object).
readonly attribute boolean | expired
| Set if the certificate has expired (relevant to the parent object)/.

## Detailed Description

X.509 certificate details.

Interface ID:
  `{392F1DE4-80E1-4A8A-93A1-67C5F92A838A}`

## Member Function Documentation

## ◆ isCurrentlyExpired()

void ICertificate::isCurrentlyExpired | ( | [retval] out boolean | result | ) |

Tests if the certificate has expired at the present time according to the X.509 validity of the certificate.

## ◆ queryInfo()

void ICertificate::queryInfo | ( | in long | what,
|  | [retval] out wstring | result
| ) |  |

Way to extend the interface.

## Member Data Documentation

## ◆ versionNumber

readonly attribute CertificateVersion ICertificate::versionNumber

Certificate version number.

## ◆ serialNumber

readonly attribute wstring ICertificate::serialNumber

Certificate serial number.

## ◆ signatureAlgorithmOID

readonly attribute wstring ICertificate::signatureAlgorithmOID

The dotted OID of the signature algorithm.

## ◆ signatureAlgorithmName

readonly attribute wstring ICertificate::signatureAlgorithmName

The signature algorithm name if known (if known).

## ◆ issuerName

readonly attribute wstring [] ICertificate::issuerName

Issuer name.

Each member of the array is on the format COMPONENT=NAME, e.g. "C=DE", "ST=Example", "L=For Instance", "O=Beispiel GmbH", "CN=beispiel.example.org".

## ◆ subjectName

readonly attribute wstring [] ICertificate::subjectName

Subject name.

Same format as issuerName.

## ◆ friendlyName

readonly attribute wstring ICertificate::friendlyName

Friendly subject name or similar.

## ◆ validityPeriodNotBefore

readonly attribute wstring ICertificate::validityPeriodNotBefore

Certificate not valid before ISO timestamp.

## ◆ validityPeriodNotAfter

readonly attribute wstring ICertificate::validityPeriodNotAfter

Certificate not valid after ISO timestamp.

## ◆ publicKeyAlgorithmOID

readonly attribute wstring ICertificate::publicKeyAlgorithmOID

The dotted OID of the public key algorithm.

## ◆ publicKeyAlgorithm

readonly attribute wstring ICertificate::publicKeyAlgorithm

The public key algorithm name (if known).

## ◆ subjectPublicKey

readonly attribute octet [] ICertificate::subjectPublicKey

The raw public key bytes.

## ◆ issuerUniqueIdentifier

readonly attribute wstring ICertificate::issuerUniqueIdentifier

Unique identifier of the issuer (empty string if not present).

## ◆ subjectUniqueIdentifier

readonly attribute wstring ICertificate::subjectUniqueIdentifier

Unique identifier of this certificate (empty string if not present).

## ◆ certificateAuthority

readonly attribute boolean ICertificate::certificateAuthority

Whether this certificate is a certificate authority.

Will return E_FAIL if this attribute is not present.

## ◆ keyUsage

readonly attribute unsigned long ICertificate::keyUsage

Key usage mask.

Will return 0 if not present.

## ◆ extendedKeyUsage

readonly attribute wstring [] ICertificate::extendedKeyUsage

Array of dotted extended key usage OIDs.

Empty array if not present.

## ◆ rawCertData

readonly attribute octet [] ICertificate::rawCertData

The raw certificate bytes.

## ◆ selfSigned

readonly attribute boolean ICertificate::selfSigned

Set if self signed certificate.

## ◆ trusted

readonly attribute boolean ICertificate::trusted

Set if the certificate is trusted (by the parent object).

## ◆ expired

readonly attribute boolean ICertificate::expired

Set if the certificate has expired (relevant to the parent object)/.